#include "Desk.h"

  Desk::Desk() {
     Dpy  = XOpenDisplay( NULL );
     Root = DefaultRootWindow( Dpy );
     Data = Imlib_init( Dpy );
	
     SpareRoot = Imlib_create_image_from_drawable( Data, Root, 0, 0, 0, WidthOfScreen( DefaultScreenOfDisplay( Dpy ) ), HeightOfScreen( DefaultScreenOfDisplay( Dpy ) ) );
     
     LoadOptions();
     LoadIcons();
     ArrangeIcons();
     Loop();
  }

  Desk::~Desk() {
    Imlib_kill_image( Data, SpareRoot );
    XftColorFree( Dpy, DefaultVisual( Dpy, DefaultScreen( Dpy ) ), DefaultColormap( Dpy, DefaultScreen( Dpy ) ), &Fore );
    XftColorFree( Dpy, DefaultVisual( Dpy, DefaultScreen( Dpy ) ), DefaultColormap( Dpy, DefaultScreen( Dpy ) ), &Shadow );
    if( HighContrast )
      XftColorFree( Dpy, DefaultVisual( Dpy, DefaultScreen( Dpy ) ), DefaultColormap( Dpy, DefaultScreen( Dpy ) ), &Back );
  }

/* This is starting to get a little out of hand... this might need recoding to use
   Xresources. -- Bryn, Oct 28 */

  void Desk::LoadOptions() {
    Database *Db;
    Table  *Config;
    string File( getenv("HOME") );
    
    // Get our Database.

    File += "/.ideskrc";

    Db = new Database( File );
    if(! (Config = Db->Query("Config"))) 
    {
      printf("Can't find config file, or missing 'Config' table in the config file.\n");
      exit(-1);
    }
    delete Db;

    // Start handling the various chunks.
	
	if (Config->Query( "Bold" ) == "true")
	  BoldVal = XFT_WEIGHT_BOLD;
	else
	  BoldVal = XFT_WEIGHT_MEDIUM;
	  
    Font = XftFontOpen( Dpy, DefaultScreen(Dpy), 
			XFT_FAMILY, XftTypeString, (char*)Config->Query("FontName").c_str(), 
			XFT_SIZE, XftTypeDouble, (double)atoi(Config->Query("FontSize").c_str()), 
			XFT_WEIGHT, XftTypeInteger, BoldVal,
			NULL );
    if( !Font )
    {
      printf( "Can't find font: %s\n", ( char * )Config->Query( "FontName" ).c_str() );
      exit( -1 );
    }
    
    XftColorAllocName( Dpy, DefaultVisual(Dpy,DefaultScreen(Dpy)), DefaultColormap(Dpy,DefaultScreen(Dpy)), (char*)Config->Query("FontColor").c_str(), &Fore );

    if( !strcmp( ( char * )Config->Query( "Shadow" ).c_str(), "true" ) )
	{
	  ShadowFlag = true;
      XftColorAllocName( Dpy, DefaultVisual(Dpy,DefaultScreen(Dpy)), DefaultColormap(Dpy,DefaultScreen(Dpy)), (char*)Config->Query("ShadowColor").c_str(), &Shadow );

	  if( Config->Query( "ShadowX" ) != "")
		ShadowX = strtol(Config->Query( "ShadowX").c_str(), NULL, 10) ;
	  else
		ShadowX = 1;

	  if( Config->Query( "ShadowY" ) != "" )
		ShadowY = strtol(Config->Query( "ShadowY").c_str(), NULL, 10) ;
	  else
		ShadowY = 1;
	}

    if( !strcmp( ( char * )Config->Query( "HighContrast" ).c_str(), "true" ) )
    {
      XRenderColor xrdc;
      // Simple negative.
      xrdc.red = 65535 - Fore.color.red;
      xrdc.blue = 65535 - Fore.color.blue;
      xrdc.green = 65535 - Fore.color.green;
      XftColorAllocValue( Dpy, DefaultVisual( Dpy, DefaultScreen( Dpy ) ), DefaultColormap( Dpy, DefaultScreen( Dpy ) ), &xrdc, &Back );
      HighContrast = true;
    }
    else if( Config->Query( "HighContrast" ).c_str()[ 0 ] == '#' )
    {
      XftColorAllocName( Dpy, DefaultVisual( Dpy, DefaultScreen( Dpy ) ), DefaultColormap( Dpy, DefaultScreen( Dpy ) ), 
			 ( char * )Config->Query("HighContrast").c_str(), &Back );
      HighContrast = true;
    }
    else
    {
      HighContrast = false;
    }
    
    if( HighContrast )
      Back.color.alpha = 21845;
    
    Transparency = atoi( (char*)Config->Query( "Transparency" ).c_str() );
    
    if( !strcmp( ( char * )Config->Query( "Locked" ).c_str(), "true" ) ) LockDesk();
    else UnlockDesk();
    
    delete Config;
  }


  void Desk::LoadIcons() {
    struct dirent **Files;
    string FileName, DirName(getenv("HOME"));
    Database *IconDb;
    Table    *IconTb;
    int FileCount;

      DirName += "/.idesktop/";
      FileCount = scandir( DirName.c_str(), &Files, 0, alphasort );

      for(int i=0; i<FileCount; i++) {
        FileName = DirName + Files[i]->d_name;
        IconDb = new Database(FileName);
        if(!(IconTb = IconDb->Query("Icon")))
	{
		free( Files[ i ] );
		delete IconDb;
		continue;
	}
        AddIcon( (char*)FileName.c_str(), (char*)IconTb->Query("Icon").c_str(), (char*)IconTb->Query("Caption").c_str(), (char*)IconTb->Query("Command").c_str(), atoi(IconTb->Query("X").c_str()), atoi(IconTb->Query("Y").c_str()) );
	free( Files[ i ] );
        delete IconDb;
	delete IconTb;
      }
      free( Files );
  }


  void Desk::SaveIcons() {
      for( int i=0; i<Icons.size(); i++ ) {
        SaveIcon( Icons[i] );
      }
  }


  void Desk::SaveIcon( Icon *I ) {
    Database *IconDb;
    Table    *IconTb;
    char     Num[10];

      IconDb = new Database(I->FileName);
        if(!(IconTb = IconDb->Query("Icon"))) return;
        sprintf(Num, "%d", I->X);
        IconTb->Set("X", Num);
        sprintf(Num, "%d", I->Y);
        IconTb->Set("Y", Num);
        IconDb->Write();
        delete IconDb;
  }

  
  void Desk::LockDesk() {
    Locked = true;
  }


  void Desk::UnlockDesk() {
    Locked = false;
  }


  bool Desk::IsLocked() {
    return Locked;
  }

  void Desk::AddIcon( char *File, char *F, char *Caption, char *Command, int X, int Y ) {
      Icon *I = new Icon( this, File, F, Caption, Command, X, Y );
      Icons.push_back( I );
  }

  
  void Desk::ArrangeIcons() {
    int MaxW = 0;
    int IconX, IconY = 20;

      if( Icons.size() == 0 ) { printf("No Icons! Quitting.\n"); exit(0); }

      for( int i=0; i<Icons.size(); i++ ) {
         Icon *I = Icons[i];
         if( I->Width > MaxW ) MaxW = I->Width;
      }
  
      IconX = WidthOfScreen(DefaultScreenOfDisplay(Dpy)) - MaxW - 20;

      for( int i=0; i<Icons.size(); i++ ) {
         Icon *I = Icons[i];
         if( IconY+I->Height+30+Font->height > HeightOfScreen(DefaultScreenOfDisplay(Dpy)) ) { IconY = 20; IconX = IconX - 20 - MaxW; }
         if( I->X == 0 && I->Y == 0 ) {
           I->X = IconX + ((MaxW - I->Width)/2);
           I->Y = IconY;
           IconY += I->Height + 30 + Font->height;
         }
         XMoveWindow( Dpy, I->Win, I->X, I->Y );
         XMapWindow( Dpy, I->Win );
         XMapWindow( Dpy, I->Text );
         I->Update( ); 
      }
  }

  void Desk::Execute( char *Command ) {
    pid_t pid2, pid = fork();

      switch( pid ) {
        case -1:
           fprintf(stderr, "Fork in Desk::Execute(X) Failed.\n");
           _exit(1);
           break;
        case 0:
           if( (pid2=fork()) < 0 ) {
             fprintf(stderr, "Fork in Desk::Execute(X) Failed.\n");
             _exit(1);
           }
           if( pid2 == 0 ) {
	     // execlp("/bin/sh", "sh", "-c", Command, NULL);
	     // bugfix: the previous line didn't work on my system (Gentoo 1.4_rc1/2.4.19-xfs-rc2) -- csm
 	     execlp("/bin/sh", "/bin/sh", "-c", Command, NULL);
             fprintf(stderr, "Desk::Execute( \"%s\" ) Failed.\n", Command);
             _exit(1); 
           }
           _exit(0);
           break;
      } waitpid(pid, NULL, 0);
  }

  Icon* Desk::FindIcon( Window Win ) {
      for( int i=0; i<Icons.size(); i++ ) {
         Icon *I = Icons[i];
         if( I->Win == Win || I->Text == Win ) return I;
      } return None;
  }

  void Desk::Loop() {
    XEvent Ev;
    Icon *I;
    static int Time = 0;

      for(;;) {
          XNextEvent( Dpy, &Ev );
	  
	  I = FindIcon( Ev.xmotion.window );
	  
	  if( !I ) continue;

          switch( Ev.type ) 
	  {
	    
	  case ButtonPress:
	    if( Ev.xbutton.button == Button1 ) I->Drag( &Ev );
	    break;
	    
	  case MotionNotify:
	    if( I->Dragging ) I->Drag( &Ev );
	    break;
	    
	  case ButtonRelease:
	    if( Ev.xbutton.button == Button1 ) I->Drag( &Ev );
	    if( Ev.xbutton.button == Button2 ) 
	    {
	      if( Ev.xbutton.time - Time <= 300 ) { SaveIcons(); Reboot(); }
	      Time = Ev.xbutton.time;
	    }
	    break;
	    
	  case Expose:
	    I->UpdateText();
	    break;
	    
	  case EnterNotify:
	    if( GetTransparency() ) I->TwiddleGlow( true );
	    break;
	  case LeaveNotify:
	    if( GetTransparency() ) I->TwiddleGlow( false );
	    break;
          }
      }
  }


  int Desk::GetTransparency( ) {
    return( Transparency );
  }

  bool Desk::GetContrast( ) {
    return( HighContrast );
  }

  bool Desk::GetShadow(int &x, int &y ) {
	x = ShadowX;
	y = ShadowY;
    return( ShadowFlag );
  }
